package de.fraunhofer.iem.dataprovider.repository.dto

import de.fraunhofer.iem.dataprovider.repository.entity.RepositoryDetailsEntity
import de.fraunhofer.iem.dataprovider.repository.entity.RepositoryEntity
import java.sql.Timestamp
import java.time.Instant

data class RepositoryDetailsDto(
    val repositoryEntity: RepositoryEntity,
    val numberOfCommits: Int,
    val numberOfSignedCommits: Int,
    val isDefaultBranchProtected: Boolean
) {
    fun toDbObject(): RepositoryDetailsEntity {
        val repositoryDetailsEntity = RepositoryDetailsEntity()
        repositoryDetailsEntity.repository = this.repositoryEntity
        repositoryDetailsEntity.timestamp = Timestamp.from(Instant.now())
        repositoryDetailsEntity.numberOfCommits = this.numberOfCommits
        repositoryDetailsEntity.numberOfSignedCommits = this.numberOfSignedCommits
        repositoryDetailsEntity.isDefaultBranchProtected = this.isDefaultBranchProtected
        return repositoryDetailsEntity
    }
}