package de.fraunhofer.iem.dataprovider.repository.entity

import jakarta.persistence.*
import org.hibernate.annotations.JdbcTypeCode
import org.hibernate.type.SqlTypes
import java.sql.Timestamp
import java.util.*

@Entity
@Table(name = "repository_details")
class RepositoryDetailsEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @ManyToOne(fetch = FetchType.EAGER)
    var repository: RepositoryEntity? = null

    @Column(name = "number_of_commits")
    var numberOfCommits: Int? = null

    @Column(name = "number_of_signed_commits")
    var numberOfSignedCommits: Int? = null

    @Column(name = "is_default_branch_protected")
    var isDefaultBranchProtected: Boolean? = null

    @JdbcTypeCode(SqlTypes.TIMESTAMP)
    @Column(name = "timestamp")
    var timestamp: Timestamp? = null
}