package de.fraunhofer.iem.dataprovider.taskManager.tasks

import de.fraunhofer.iem.dataprovider.logger.getLogger
import de.fraunhofer.iem.dataprovider.taskManager.events.Event
import java.util.*

interface ITask {
    suspend fun execute()
    val taskID: UUID
}

abstract class Task : ITask {
    override val taskID: UUID = UUID.randomUUID()
    protected open val groupID: UUID? = null

    protected val logger = getLogger(javaClass)
    protected abstract val responseChannel: suspend (event: Event) -> Unit
}
