package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json

import de.fraunhofer.iem.dataprovider.toolRun.entity.ToolRunEntity
import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable
import java.sql.Timestamp
import java.time.Instant

@Serializable
data class SarifRunJson(
    @SerialName("results")
    val results: List<SarifResultJson>,
    @SerialName("tool")
    val tool: SarifToolJson
)

fun SarifRunJson.asDbObject(): ToolRunEntity {
    val tr = ToolRunEntity()
    tr.timeStamp = Timestamp.from(Instant.now())
    return tr
}
