package de.fraunhofer.iem.dataprovider.toolRun.entity

import de.fraunhofer.iem.dataprovider.tool.entity.RuleEntity
import de.fraunhofer.iem.dataprovider.toolRun.enumeration.KindEnum
import de.fraunhofer.iem.dataprovider.toolRun.enumeration.LevelEnum
import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "finding")
class FindingEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @ManyToOne
    var rule: RuleEntity? = null

    @OneToMany(mappedBy = "findingEntity", cascade = [CascadeType.ALL], orphanRemoval = true)
    var locationEntities: MutableSet<LocationEntity> = mutableSetOf()

    fun addLocations(locationEntities: Collection<LocationEntity>) {
        locationEntities.forEach {
            this.addLocation(it)
        }
    }

    fun addLocation(locationEntity: LocationEntity) {
        locationEntities.add(locationEntity)
        locationEntity.findingEntity = this
    }

    @Enumerated
    @Column(name = "level")
    var level: LevelEnum? = null

    @Enumerated
    @Column(name = "kind")
    var kind: KindEnum? = null

    @Column(name = "message", columnDefinition = "TEXT")
    var message: String? = null

    @ManyToOne
    var toolRun: ToolRunEntity? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as FindingEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}