package de.fraunhofer.iem.dataprovider

import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.ort.getHighestScore
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.ort.getOrtResultsFromFile
import org.junit.jupiter.api.Test
import java.nio.file.Paths

class ParseOrtAdvisorResult {

    @Test
    fun parseOrt() {
        val res =
            getOrtResultsFromFile(Paths.get("src/test/kotlin/de/fraunhofer/iem/dataprovider/ort-advisor-example-results.json"))

        assert(res[0].identifier == "first" && res[1].identifier == "second")
        assert(res[0].vulnerabilities?.get(0)?.id == "CVE-2021-45105")
        assert(res[0].vulnerabilities?.get(0)?.references?.get(0)?.severity == "6.6")

        assert(getHighestScore(res) == 8.6)
    }


}